MODULE DARBOL;
FROM IO IMPORT RdChar, WrChar,WrCard, WrStr, RdCard, WrLn, RdStr, RdLn,
               RdKey, KeyPressed;
FROM Window IMPORT Clear;
FROM Cadenas IMPORT Comp;
FROM ArbolBB IMPORT ARBOLBB,ITEM,ERROR, TPalabra,Crear,Vacio,Info,Izq,Dcho,
                   Esta,Insertar, Borrar, Destruir;


PROCEDURE Pausa;
BEGIN
  WrStr("Pulse una tecla para continuar ");
  REPEAT UNTIL KeyPressed();
END Pausa;

PROCEDURE Chequea(error:ERROR);
BEGIN
   CASE error OF
       SinError:
     | SinMemoria: WrStr(" Error. No hay memoria para crear la estructura Arbol");WrLn;
                   Pausa;
     | NoEsta:     WrStr(" Error. No esta el elemento buscado");WrLn;
                   Pausa;
     | YaEsta:     WrStr(" Error. Ya existe el elemento buscado");WrLn;
                   Pausa;
     | NoCreado:   WrStr(" Error. La estructura no ha sido creada");WrLn;
                   Pausa;
     | ArbolVacio: WrStr(" Error. La estructura esta vacia");WrLn;
                   Pausa;
     | ELSE
   END;
END Chequea;

PROCEDURE valido(c:CHAR):BOOLEAN;
VAR result:BOOLEAN;
BEGIN
  IF ('A'<=CAP(c)) AND (CAP(c)<='Z') THEN
    result:=TRUE
  ELSE
    result:=FALSE
  END;
  RETURN result;
END valido;


(*ESte proc. busca el elemento a modificar moviendose por el arbol.
  Ya se sabe que esta, por eso no se chequea que el arbol
  sea vacio. En resultado devuelve el registro buscado -con su
  contador incluido. En dato simplemente me interesa la Clave,
  o se la cadena que debo buscar   *)

PROCEDURE Busca(a:ARBOLBB;dato:ITEM;VAR resultado:ITEM);
VAR error:ERROR;
    izq,dch:ARBOLBB;
BEGIN
  resultado:=Info(a,error);
  Chequea(error);
  IF Comp(dato.Clave,resultado.Clave)=-1 THEN
     izq:=Izq(a,error);
     Chequea(error);
     Busca(izq,dato,resultado)
  ELSIF Comp(dato.Clave,resultado.Clave)=1 THEN
     dch:=Dcho(a,error);
     Chequea(error);
     Busca(dch,dato,resultado)
  END;
END Busca;

PROCEDURE Visualizar_Arbol(a:ARBOLBB);
(* Visualiza el arbol en Inorden tal como pide la practica *)

VAR vacio:BOOLEAN;
   izq,dch:ARBOLBB;
   error:ERROR;
   dato:ITEM;
BEGIN
   vacio:=Vacio(a,error);
   Chequea(error);
   IF NOT vacio THEN
      izq:=Izq(a,error);
      Chequea(error);
      Visualizar_Arbol(izq);

      dato:=Info(a,error);
      Chequea(error);
      WrLn;
      WrStr(dato.Clave); WrStr("..........");
      WrCard(dato.Cont,4);WrLn;

      dch:=Dcho(a,error);
      Chequea(error);
      Visualizar_Arbol(dch);
    END;
 END Visualizar_Arbol;

VAR arbol:ARBOLBB;
    error:ERROR;
    car:CHAR;
    palabra:TPalabra;
    i:CARDINAL;
    dato,resultado:ITEM;
    esta:BOOLEAN;

BEGIN
  Crear(arbol,error);
  Chequea(error);
  WrStr("Introduzca un texto ");WrLn;
  car:=RdKey();
  i:=1;
  WHILE ORD(car) <> 27 DO      (* CHR(27)= caracter Esc *)
    WHILE valido(car) DO       (* Lee una palabra hasta que sea un car.no valido *)
       WrChar(car);
       palabra[i]:=car;
       INC(i);
       car:=RdKey();
    END;
    IF i<=15 THEN
       palabra[i]:=CHR(0);
    END;
    dato.Clave:=palabra;
    esta:=Esta(arbol,dato,error);
    Chequea(error);
    IF (i>1) THEN  (*si i es mayor que 1 entonces hay palabra valida*)
      IF NOT esta THEN
         dato.Cont:=1;
         Insertar(arbol,dato,error);
         Chequea(error)
      ELSE
         Busca(arbol,dato,resultado);
         resultado.Cont:=resultado.Cont+1;
         Borrar(arbol,dato,error);
         Chequea(error);
         Insertar(arbol,resultado,error);
         Chequea(error)
      END;
      i:=1;
    END;
    IF car <> CHR(27) THEN
       WrChar(car);
       car:=RdKey()
    END;
  END;
  Visualizar_Arbol(arbol);
  Destruir(arbol,error);
  Chequea(error);
END DARBOL.